#ifndef SCHEDULE_BLOC_1D_IS_DEFINED
#define SCHEDULE_BLOC_1D_IS_DEFINED

#include <vector>
#include "XServiceIDL.h"

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

typedef struct GlobalData_s {
  unsigned len;
  unsigned unit_size;
} GlobalData_t;

typedef struct LocalData_s {

  unsigned rank;
  
  unsigned start; // global offset
  unsigned len;

  char* base;
} LocalData_t;

typedef struct Topology_s {
  unsigned total;
} Topology_t;

//enum distLoc_t { ClientSide, ServerSide, CommSide };

////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////

class Abstrait {    

public:
  virtual PaCo::PacoTopology_t& topo()=0;
  virtual PaCo::PacoGlobalData_t& gd()=0;
  virtual PaCo::seqLocalData_t& dist()=0;

  virtual void  seqDataLength(const unsigned)=0;

  virtual unsigned getDataLength(const unsigned) const =0;

  virtual void  DataLength(const unsigned, const unsigned)=0;
  virtual char* DataGetBuffer(const unsigned, const bool)=0;
  virtual void  DataReplace(const unsigned,  const unsigned long, void* ptr, const bool )=0;

};

class vAbstrait {

public:
  virtual void clear()=0;
  virtual void resize(unsigned size)=0;

  virtual Abstrait* operator[](const unsigned)=0;

};

//////////////////////////////////////////////////////////////////////////////////

// vOut represents what localData/stopo have to send to nodes of dtopo (vOut[].rank is in dtopo space)
void computeSendBlock1D(const GlobalData_t& gd, const LocalData_t &sd, 
			const Topology_t &stopo, const Topology_t &dtopo,
			vector<LocalData_t>& vOut);

// vOut represents what localData/dtopo have to receive from nodes of stopo (vOut[].rank is in stopo space)
void computeReceiveBlock1D(const GlobalData_t& gd, const LocalData_t &dd, 
			   const Topology_t &stopo, const Topology_t &dtopo,
			   vector<LocalData_t>& vOut);

// vOut represents what localData/stopo have to send to nodes of dtopo (vOut[].rank is in dtopo space)
void computeSendRemoteDataBlock1D(const GlobalData_t& gd, const LocalData_t &sd, 
				  const Topology_t &stopo, const Topology_t &dtopo,
				  vector<LocalData_t>& vOut, const PaCo::distLoc_t mode);


//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

void computeSendDataBlock1D(const GlobalData_t& gd, const LocalData_t &sd, 
			    const Topology_t &stopo, const Topology_t &dtopo,
			    vAbstrait& vdarray, vector<unsigned>& destid,
			    const PaCo::distLoc_t& mode);

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

#endif
