#ifndef XSERVICECORBA_IS_DEFINIED
#define XSERVICECORBA_IS_DEFINIED

#include "Padico/PM2.h"

#include "XServiceIDL.h"
#include "XServiceType.h"

class XServiceIDL_impl : virtual public POA_Server1D
{
private:
  unsigned int rank;
  unsigned int total;

  PaCo::ConnectionInfos ci;
  marcel_sem_t ci_sem;

  xservice_data_t* data;
  unsigned int llen;
  unsigned int glen;

  vector<PaCo::DistributionBlock1DLong_t> incomingData;
  
  unsigned int received;
  marcel_sem_t ready_sem;
  void wait() { this->data=0; marcel_sem_P(&ready_sem); }
  void release() {  marcel_sem_V(&ready_sem); }

  marcel_sem_t waitSendData_sem;

  PaCo::distLoc_t mode;

public:
  XServiceIDL_impl() {
    marcel_sem_init(&ready_sem,0);
    marcel_sem_init(&waitSendData_sem,0);
    data=0;
    received=0;

    mode = PaCo::ServerSide;
  }

  // PaCO stuff
  void init_InterfaceParallel(CORBA::Short myRank, CORBA::Short totalNode, const char* ior);
  void init_InterfaceParallel2(CORBA::Short myRank, CORBA::Short totalNode, const char* ior);
  PaCo::ConnectionInfos* getConnectionInfos(void);
  void setConnectionInfos(const PaCo::ConnectionInfos& infos);
  void initConnectionInfos(const char* ior, CORBA::Short from);

  void setLocationRedistribution(PaCo::distLoc_t mode);
  PaCo::distLoc_t getLocationRedistribution();

  // Example stuf
  void sendData(const PaCo::DistributionBlock1DLong_t& darray);
  void sendDataOk();
  void waitSendData();
  void kill();

  // Local stuff
  int waitData1DBlock(xservice_data_t **data, unsigned int* llen, unsigned int *glen);
};

#endif
