/* Padico tutorial 2: MPI
 * author: Christian Prez
 */

#include <stdio.h>
#include <mpi.h>
#include "MPIService.h"

#include <Padico/Puk.h>
#include <Padico/Module.h>

/************************************************************/
/************************************************************/
/************************************************************/

static int counter;

/************************************************************/
/************************************************************/
/************************************************************/

PADICO_MODULE_DECLARE(MPIService);
PADICO_MODULE_INIT(MPIService_internal_init);
PADICO_MODULE_FINALIZE(MPIService_internal_finalize);

/************************************************************/

int MPIService_internal_init(void)
{
  padico_print("MPIService: module init\n");
  counter=0;
  return 0;
}

/************************************************************/

void MPIService_internal_finalize(void)
{
  padico_print("MPIService: module finalize (counter= %d)\n",counter);
}


/************************************************************/

void MPIService_init() {

  fprintf(stderr," counter: %d\n", counter);
  counter++;
}

/************************************************************/
/************************************************************/
/************************************************************/

/*
 * int MPI_Allreduce ( void *sendbuf, void *recvbuf, int count, 
 *                     MPI_Datatype datatype, MPI_Op op, MPI_Comm comm )
 *
 * int MPI_Reduce(void *sbuf, void* rbuf, int count,
 *                MPI_Datatype dtype, MPI_Op op, int root,
 *                MPI_Comm comm)
 */

int myReduce(int a) {

  int r;

  MPIService_init();

  MPI_Allreduce(&a, &r, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD);

  return r;
}

/************************************************************/
/************************************************************/
/************************************************************/


