#include <Padico/Module.h>
#include <Padico/PadicoTM.h>
#include <Padico/Puk.h>
#include <Padico/Timing.h>

#include "dummy.h"

PADICO_MODULE_DECLARE(Test_Far);
PADICO_MODULE_INIT(test_far_init);


/* ********************************************************* */
/* *** drivers */

static void*test_far_instanciate(puk_instance_t ai, puk_context_t context);
static void test_far_destroy(void*_instance);

const static struct puk_adapter_driver_s test_far_adapter_driver =
  {
    .instanciate = &test_far_instanciate,
    .destroy     = &test_far_destroy
  };

static int test_far_dummy(int a);

const static struct padico_dummy_driver_s test_far_dummy_driver =
  {
    .dummy = &test_far_dummy
  };


/* ********************************************************* */
/* *** implementation */

static void*test_far_instanciate(puk_instance_t instance, puk_context_t context)
{
  return padico_malloc(sizeof(int));
}

static void test_far_destroy(void*_instance)
{
  free(_instance);
}

static int test_far_dummy(int a)
{
  return a;
}

/* ********************************************************* */
/* *** init */

static int test_far_init(void)
{
  puk_adapter_declare("TestFar",
		      puk_component_provides("PadicoAdapter", "adapter", &test_far_adapter_driver),
		      puk_component_provides("Dummy",         "dummy", &test_far_dummy_driver));
  return 0;
}

/* *** misc */

extern int test_extern_dummy(int a)
{
  return a;
}
