/** @file
 * @brief Address database
 */


#ifndef PADICO_ADDRDB_H
#define PADICO_ADDRDB_H

#include <Padico/PadicoTM.h>
#include <Padico/Topology.h>

#ifdef __cplusplus
extern "C" {
#endif

  /* *** Address DB */

  void padico_addrdb_publish(padico_na_node_t node, const char*component,
			     const void*instance, int instance_size,
			     const void*addr, int addr_size);
  
  void padico_addrdb_get(padico_na_node_t node, const char*component,
			 const void*instance, int instance_size,
			 void*addr, int addr_size, padico_req_t req);


#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* PADICO_ADDRDB_H */

