/** @file
 * @brief PadicoTM PSP module
 * @ingroup PSP
 */

#include <Padico/Puk.h>
#include <Padico/PM2.h>
#include <Padico/PadicoTM.h>
#include <Padico/Module.h>
#include <Padico/Topology.h>

#include "PSP.h"

PADICO_MODULE_DECLARE(PSP)
PADICO_MODULE_INIT(padico_psp_init);
PADICO_MODULE_FINALIZE(padico_psp_finalize);


/* ********************************************************** */

static int padico_psp_init(void)
{
  padico_out(30, "module_init()\n");

  puk_iface_register("PadicoSimplePackets");

  return 0;
}

static void padico_psp_finalize(void)
{
  padico_out(30, " module_finalize()\n");
}

