/** @file
 * @brief Internal structures definition for VLink-selector.
 * @ingroup VIO
 */

#ifndef VLINK_SELECTOR_INTERNALS_H
#define VLINK_SELECTOR_INTERNALS_H

#include <Padico/Topology.h>
#include <Padico/VLink-API.h>


/* ********************************************************* */
/* *** VLink-resolver ************************************** */

__PUK_SYM_INTERNAL
void           vlink_registry_register(padico_vnode_t, const struct sockaddr*, socklen_t, int);
__PUK_SYM_INTERNAL
void           vlink_registry_unregister(padico_vnode_t);
__PUK_SYM_INTERNAL
padico_vnode_t vlink_registry_lookup(const struct sockaddr*, socklen_t, int);

__PUK_SYM_INTERNAL
padico_na_node_t vlink_resolver_resolve_node(const struct padico_vaddr_s*vaddr);
__PUK_SYM_INTERNAL
padico_na_host_t vlink_resolver_resolve_host(const struct padico_vaddr_s*vaddr);

__PUK_SYM_INTERNAL
void padico_vlink_resolver_init(void);


#endif /* VLINK_SLEECTOR_INTERNALS_H */
