
# ## check build directory
AC_DEFUN([AC_PADICO_BUILDDIR],
	 [ AC_MSG_CHECKING([PadicoTM build directory])
	   padico_builddir=`pwd`
	   if test -r ./configure; then
	     AC_MSG_ERROR([ *** PadicoTM must not be configured in its source tree. Create a separate 'build' dir instead. ])
	   fi
	   AC_SUBST(padico_builddir)
	   AC_MSG_RESULT(${padico_builddir})
	   padico_root=$prefix
           AC_SUBST(padico_root)
           AC_DEFINE_UNQUOTED(PADICO_ROOT, "${padico_root}/", 
                              [Padico root install directory])

           if test x$prefix = xNONE; then
             AC_MSG_ERROR([No prefix given. Please supply a '--prefix' parameter.])
           fi
	 ])
# ## check source directory
AC_DEFUN([AC_PADICO_SRCDIR],
	 [ AC_MSG_CHECKING([PadicoTM source directory])
	   case ${srcdir} in
	     /*) padico_srcdir=${srcdir} ;;
	     *)  padico_srcdir="`pwd`/${srcdir}" ;;
	   esac
	   AC_SUBST(padico_srcdir)
	   AC_MSG_RESULT(${padico_srcdir})
	 ])

#  ## Various installation directories
AC_DEFUN([AC_PADICO_DIRS],
	 [ AC_REQUIRE([AC_PADICO_BUILDDIR])

           padico_mod_path=${padico_root}/var/mod
           AC_SUBST(padico_mod_path)
           AC_DEFINE_UNQUOTED(PADICO_MOD_PATH, "${padico_mod_path}/",
                              [Padico modules directory (usually PADICO_ROOT/var/mod)])
	 ])


# ## Version and version strings
AC_DEFUN([AC_PADICO_VERSION],
	 [ AC_REQUIRE([AC_PADICO_SRCDIR])
	   PACKAGE_NAME="$1"
	   AC_MSG_CHECKING([${PACKAGE_NAME} version])
	   if test -r ${padico_srcdir}/../building-tools/VERSION; then
	     PACKAGE_VERSION="`cat ${padico_srcdir}/../building-tools/VERSION`"
 	   else
	     AC_MSG_ERROR([ cannot find VERSION. ])
           fi
	   PACKAGE_STRING="${PACKAGE_NAME}-${PACKAGE_VERSION}"
 	   PACKAGE_TARNAME="${PACKAGE_STRING}.tar.gz"
           PACKAGE_BUGREPORT="<padico-users@listes.irisa.fr>"

	   AC_MSG_RESULT([ $PACKAGE_STRING ])

	   PADICO_VERSION=${PACKAGE_VERSION}
	   AC_SUBST(PADICO_VERSION)

           padico_build_string="${PACKAGE_STRING} (`date`)"
	   AC_DEFINE_UNQUOTED(PADICO_BUILD_STRING, "${padico_build_string}", [date of the build])

	   AC_DEFINE_UNQUOTED(PADICO_VERSION_STRING, "${PACKAGE_STRING}",
			      [Padico version as string])
	 ])

